<script>
import { mapGetters, mapState } from 'vuex';

export default {
  name: `anim-rig-user-lib-card`,
  props: {
    lib: { type: Object, required: true },
  },
  data() {
    return {
      editing: false,
      editedLibName: ``,
      showPublishModal: false,
      showDeleteModal: false,
      showReviveModal: false,
    }
  },
  computed: {
    ...mapGetters('projects', [ 'isWriter' ]),
    ...mapState({
      username: (state) => state.users.currentUser.username,
      isAnimLead: (state) => state.users.currentUser.roles.includes(`anim-lead`),
    }),
    isMyLib() {
      return !this.lib.public && this.lib.owner === this.username;
    },
    isInactive() {
      return !this.lib.active;
    },
    iAmWriter() {
      return this.isWriter(this.username);
    },
  },
  methods: {
    toggleEdit() {
      this.editedLibName = this.lib.name;
      this.editing = true;
      setTimeout(() => {
        this.$refs[`edit-lib-name`].focus();
      }, 100);
    },
    closePublishModal() {
      this.showPublishModal = false;
    },
    closeDeleteModal() {
      this.showDeleteModal = false;
    },
    closeReviveModal() {
      this.showReviveModal = false;
    },
    publishLibrary() {
      this.$emit(`publish`);
      this.closePublishModal();
    },
    deleteLibrary() {
      this.$emit(`delete`);
      this.closeDeleteModal();
    },
    reviveLibrary() {
      this.$emit(`revive`);
      this.closeReviveModal();
    },
    setLibraryName() {
      if (this.editedLibName !== `` && this.editedLibName !== this.lib.name) {
        this.$emit(`set-name`, this.editedLibName);
      }
      this.editedLibName = ``;
      this.editing = false;
    },
    toggleLibraryFavorite() {
      this.$emit(`toggle-favorite`, !this.lib.favorite);
    },
    onCardClick() {
      if (this.editing) return;
      this.$router.push({
        path: this.localePath(`/anim-rig/${this.lib.name}`),
        query: this.$route.query,
      });
    },
  },
}
</script>

<template>
  <cbr-card
    :to="(editing) ? null : { path: localePath(`/anim-rig/${lib.name}`), query: $route.query }"
    :disabled="isInactive"
    :style="{ 'margin-left': `${lib.indent * 20}px` }"
    class="card"
  >
    <cbr-modal v-model="showPublishModal"
              :title="$t(`anim-rig.publish-lib.title`)"
              :onCancel="closePublishModal"
              :onConfirm="publishLibrary"
              :confirm-text="$t(`common.publish`)">
      {{ $t(`anim-rig.publish-lib.content`, { name: lib.name }) }}
    </cbr-modal>
    <cbr-modal v-model="showDeleteModal"
              :title="$t(`anim-rig.delete-lib.title`)"
              :onCancel="closeDeleteModal"
              :onConfirm="deleteLibrary"
              :confirm-text="$t(`common.delete`)"
              confirm-color="error">
      {{ $t(`anim-rig.delete-lib.content`, { name: lib.name }) }}
    </cbr-modal>
    <cbr-modal v-model="showReviveModal"
              :title="$t(`anim-rig.revive-lib.title`)"
              :onCancel="closeReviveModal"
              :onConfirm="reviveLibrary"
              :confirm-text="$t(`common.revive`)">
      {{ $t(`anim-rig.revive-lib.content`, { name: lib.name }) }}
    </cbr-modal>
    <v-row no-gutters>
      <v-row no-gutters align="center">
        <v-btn icon class="mr-2" @click.stop="toggleLibraryFavorite">
          <v-icon>
            {{ lib.favorite ? `mdi-star` : `mdi-star-outline` }}
          </v-icon>
        </v-btn>
        <v-icon v-if="lib.public" class="mr-2">mdi-web</v-icon>
        <div class="text-subcaption" v-if="!editing">{{ lib.name }}</div>
        <v-text-field
          v-else
          type="text"
          ref="edit-lib-name"
          v-model="editedLibName"
          @blur="setLibraryName"
          @keypress.enter="setLibraryName"
          dense
          hide-details
        />
      </v-row>
      <v-spacer />
      <v-row no-gutters v-if="iAmWriter && (isMyLib || isAnimLead)" class="flex-grow-0">
        <v-btn
          icon
          @click.stop="toggleEdit"
        >
          <v-icon>mdi-pencil-outline</v-icon>
        </v-btn>
        <v-btn
          v-if="isAnimLead"
          icon
          @click.stop="showPublishModal = true"
        >
          <v-icon>mdi-web</v-icon>
        </v-btn>
        <v-btn
          v-if="!isInactive"
          icon
          @click.stop="showDeleteModal = true"
        >
          <v-icon>mdi-delete</v-icon>
        </v-btn>
        <v-btn
          v-else
          icon
          @click.stop="showReviveModal = true"
        >
          <v-icon>mdi-backup-restore</v-icon>
        </v-btn>
      </v-row>
    </v-row>
  </cbr-card>
</template>
